aboutsummaryrefslogtreecommitdiffstats
path: root/main/linux-pae/APKBUILD
diff options
context:
space:
mode:
authorCedric Schieli <cschieli@gmail.com>2010-03-21 12:31:06 +0000
committerNatanael Copa <ncopa@alpinelinux.org>2010-03-31 08:31:54 +0000
commit52880362233e075e04275cb4b0f03f536b234dca (patch)
tree596efc7d4fff041d81943dfb8a4eeb729a3356b3 /main/linux-pae/APKBUILD
parent30a60b2df8350bb862bc64fecdfb581b9cb5011b (diff)
downloadaports-52880362233e075e04275cb4b0f03f536b234dca.tar.gz
aports-52880362233e075e04275cb4b0f03f536b234dca.tar.bz2
aports-52880362233e075e04275cb4b0f03f536b234dca.tar.xz
main/linux-pae: new aport
Signed-off-by: Cedric Schieli <cschieli@gmail.com>
Diffstat (limited to 'main/linux-pae/APKBUILD')
-rw-r--r--main/linux-pae/APKBUILD130
1 files changed, 130 insertions, 0 deletions
diff --git a/main/linux-pae/APKBUILD b/main/linux-pae/APKBUILD
new file mode 100644
index 0000000000..cee800733a
--- /dev/null
+++ b/main/linux-pae/APKBUILD
@@ -0,0 +1,130 @@
+# Maintainer: Natanael Copa <ncopa@alpinelinux.org>
+
+_flavor=pae
+pkgname=linux-${_flavor}
+pkgver=2.6.32.10
+_kernver=2.6.32
+pkgrel=0
+pkgdesc="Linux kernel with PAE enabled"
+url=http://www.kernel.org
+depends="mkinitfs linux-firmware"
+makedepends="perl installkernel"
+options="!strip"
+_config=${config:-kernelconfig.${CARCH:-x86}}
+install=
+source="ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$_kernver.tar.bz2
+ ftp://ftp.kernel.org/pub/linux/kernel/v2.6/patch-$pkgver.bz2
+ ip_gre.patch
+ ip_gre2.patch
+ arp.patch
+ xfrm-cache-size-revert.patch
+ net-git-78f1cd-r8169-fix-broken-register-writes.patch
+ net-git-c0cd88-r8169-offical-fix-for-CVE-2009-4537-overlength-frame-DMAs.patch
+ kernelconfig.x86
+ "
+subpackages="$pkgname-dev"
+license="GPL-2"
+
+_abi_release=${pkgver}-${_flavor}
+
+prepare() {
+ cd "$srcdir"/linux-$_kernver
+ if [ "$_kernver" != "$pkgver" ]; then
+ bunzip2 -c < ../patch-$pkgver.bz2 | patch -p1 -N || return 1
+ fi
+
+ for i in ../*.diff ../*.patch; do
+ [ -f $i ] || continue
+ msg "Applying $i..."
+ patch -s -p1 -N < $i || return 1
+ done
+
+ mkdir -p "$srcdir"/build
+ cp "$srcdir"/$_config "$srcdir"/build/.config
+ echo "-${_flavor}" > "$srcdir"/linux-$_kernver/localversion-${_flavor}
+ make -C "$srcdir"/linux-$_kernver O="$srcdir"/build HOSTCC="$CC" \
+ silentoldconfig
+}
+
+# this is so we can do: 'abuild menuconfig' to reconfigure kernel
+menuconfig() {
+ cd "$srcdir"/build || return 1
+ make menuconfig
+ cp .config "$startdir"/$_config
+}
+
+build() {
+ cd "$srcdir"/build
+ make CC="$CC" || return 1
+}
+
+package() {
+ cd "$srcdir"/build
+ mkdir -p "$pkgdir"/boot "$pkgdir"/lib/modules
+ make modules_install install \
+ INSTALL_MOD_PATH="$pkgdir" \
+ INSTALL_PATH="$pkgdir"/boot
+
+ rm -f "$pkgdir"/lib/modules/${_abi_release}/build \
+ "$pkgdir"/lib/modules/${_abi_release}/source
+ rm -rf "$pkgdir"/lib/firmware
+
+ install -D include/config/kernel.release \
+ "$pkgdir"/usr/share/kernel/$_flavor/kernel.release
+}
+
+dev() {
+ # copy the only the parts that we really need for build 3rd party
+ # kernel modules and install those as /usr/src/linux-headers,
+ # simlar to what ubuntu does
+ #
+ # this way you dont need to install the 300-400 kernel sources to
+ # build a tiny kernel module
+ #
+ pkgdesc="Headers and script for third party modules for grsec kernel"
+ local dir="$subpkgdir"/usr/src/linux-headers-${_abi_release}
+
+ # first we import config, run prepare to set up for building
+ # external modules, and create the scripts
+ mkdir -p "$dir"
+ cp "$srcdir"/$_config "$dir"/.config
+ make -j1 -C "$srcdir"/linux-$_kernver O="$dir" HOSTCC="$CC" \
+ silentoldconfig prepare scripts
+
+ # remove the stuff that poits to real sources. we want 3rd party
+ # modules to believe this is the soruces
+ rm "$dir"/Makefile "$dir"/source
+
+ # copy the needed stuff from real sources
+ #
+ # this is taken from ubuntu kernel build script
+ # http://kernel.ubuntu.com/git?p=ubuntu/ubuntu-jaunty.git;a=blob;f=debian/rules.d/3-binary-indep.mk;hb=HEAD
+ cd "$srcdir"/linux-$_kernver
+ find . -path './include/*' -prune -o -path './scripts/*' -prune \
+ -o -type f \( -name 'Makefile*' -o -name 'Kconfig*' \
+ -o -name 'Kbuild*' -o -name '*.sh' -o -name '*.pl' \
+ -o -name '*.lds' \) | cpio -pdm "$dir"
+ cp -a drivers/media/dvb/dvb-core/*.h "$dir"/drivers/media/dvb/dvb-core
+ cp -a drivers/media/video/*.h "$dir"/drivers/media/video
+ cp -a drivers/media/dvb/frontends/*.h "$dir"/drivers/media/dvb/frontends
+ cp -a scripts include "$dir"
+ find $(find arch -name include -type d -print) -type f \
+ | cpio -pdm "$dir"
+
+ install -Dm644 "$srcdir"/build/Module.symvers \
+ "$dir"/Module.symvers
+
+ mkdir -p "$subpkgdir"/lib/modules/${_abi_release}
+ ln -sf /usr/src/linux-headers-${_abi_release} \
+ "$subpkgdir"/lib/modules/${_abi_release}/build
+}
+
+md5sums="260551284ac224c3a43c4adac7df4879 linux-2.6.32.tar.bz2
+0f1863836bf96fd0aab128d61eaa5693 patch-2.6.32.10.bz2
+3ef822f3a2723b9a80c3f12954457225 ip_gre.patch
+13ca9e91700e459da269c957062bbea7 ip_gre2.patch
+4c39a161d918e7f274292ecfd168b891 arp.patch
+329fcab881425e001d3243caa4648478 xfrm-cache-size-revert.patch
+21ed38773d846097b7315e1e0801d87a net-git-78f1cd-r8169-fix-broken-register-writes.patch
+962a6dd7c639612fc8bdaeb836388b0b net-git-c0cd88-r8169-offical-fix-for-CVE-2009-4537-overlength-frame-DMAs.patch
+bf15e3ee69e03319dab0d59e08b67195 kernelconfig.x86"